<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="search.keyWord" placeholder="关键字" style="width: 200px;" class="filter-item" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="searchData">
        搜索
      </el-button>
      <el-button
        class="filter-item"
        style="margin-left: 10px;"
        type="primary"
        icon="el-icon-plus"
        @click="handleCreateAdd">
        增加人员档案
      </el-button>
    </div>
    <el-table
      :data="tableData"
      v-loading="listLoading"
      style="width: 100%;margin-bottom: 20px;"
      row-key="id"
      border
      default-expand-all>
      <el-table-column
        prop="userName"
        label="用户名">
      </el-table-column>
     <el-table-column
        label="登录账号"
        prop="loginName"
      >
      </el-table-column>
      <el-table-column
        prop="email"
        label="邮箱">
      </el-table-column>
      <el-table-column
        prop="phoneNumber"
        label="电话">
      </el-table-column>
      <el-table-column
        prop="sex"
        label="性别">
        <template slot-scope="{row}">
          <span v-if="row.sex==0">
            女
          </span>
          <span v-else="row.sex==1">
            男
          </span>
        </template>
      </el-table-column>
      <el-table-column align="center" label="状态" class-name="status-col" width="100">
        <template slot-scope="{row}">
          <el-tag v-if="row.delFlag==0" type="success">
            启用
          </el-tag>
          <el-tag v-else="row.delFlag==1" type="danger">
            禁用
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" width="230" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <el-button @click="handleUpdate(row)" type="primary" size="mini">
            编辑
          </el-button>
          <el-button @click="editStatus(row.id,'1')" type="danger" v-if="row.delFlag==0" size="mini">
            禁用
          </el-button>
          <el-button @click="editStatus(row.id,'0')" v-else="row.delFlag==1" size="mini">
            启用
          </el-button>


        </template>
      </el-table-column>

    </el-table>
    <pagination v-show="listData.total>0" :total="listData.total" :page.sync="listData.page" :limit.sync="listData.pageSize" @pagination="getInfo" />


    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible">
      <el-form label-width="130px" label-position="right">
        <el-form-item label="用户名">
          <el-input v-model="form.userName"></el-input>
        </el-form-item>
        <el-form-item label="登录账号">
          <el-input v-model="form.loginName"></el-input>
        </el-form-item>
        <el-form-item label="密码">
          <el-input v-model="form.password"></el-input>
        </el-form-item>
        <el-form-item label="邮箱">
          <el-input v-model="form.email"></el-input>
        </el-form-item>
        <el-form-item label="电话">
          <el-input v-model="form.phoneNumber"></el-input>
        </el-form-item>

        <el-form-item label="性别">
          <el-radio v-model="form.sex" :label="0">女</el-radio>
          <el-radio v-model="form.sex" :label="1">男</el-radio>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogStatus==='1'?addBtn():editBtn()">确 定</el-button>
      </div>
    </el-dialog>
<!--    <servicedialog @tableRefresh="tableRefresh" ref="menuDialog" :dialogStatus="dialogStatus" :menuId="menuId" :titleDialog="titleDialog" :dialogVisible="dialogVisible"/>-->
    <cancledialog @tableRefresh="tableRefresh" ref="confirmDialog"></cancledialog>
  </div>
</template>

<script>
  import {addPersonFileInfo,getPersonFileInfoList,getPersonFileInfoByID,updatePersonFileInfo} from '@/api/baseInfo/personFileInfo.js'
  import Cancledialog from '@/components/Dialog/Cancledialog.vue'
  import Pagination from '@/components/Pagination'
  const form = {
    loginName:'',
    userName:'',
    email:'',
    phoneNumber:'',
    sex:'',
    password:'',
  }
  export default {
    components: {
      Cancledialog,Pagination
    },
    filters: {
      statusFilter(status) {
        const statusMap = {
          1: 'success',
          0: 'danger'
        }
        return statusMap[status]
      }
    },
    data() {
      return {
        dialogStatus: 1,//1增加，2修改
        dialogTitle: '',
        dialogVisible: false,
        search: {
          keyWord:''
        },
        form: Object.assign({}, form),
        listData:{
          total:0,
          page: 1,
          pageSize:10
        },

        options:[],

        confirmdialog:false,
        listLoading: false,
        tableData: [],
        menuId:''
      }
    },
    mounted() {
      this.getInfo();
    },
    methods: {
      //获取列表
      getInfo() {
        const _that = this
        _that.listLoading = true


        var params =_that.search;
        var page = {
          pageIndex:_that.listData.page,
          pageSize: _that.listData.pageSize,
        }
        var data = {
          "params": JSON.stringify(params),
          "page": JSON.stringify(page),
        }

        getPersonFileInfoList(data).then(response => {
          console.log(response)
          const data = response.data
          // //  组合表单数据
          _that.tableData = data
          // console.log(_that.tableData)
          _that.listData.total = response.total
          _that.listLoading = false
        }).catch(err => {
          _that.$message.error(err)
          _that.listLoading = false
        })
      },
      //增加人员档案
      handleCreateAdd(){
        //增加系统目录
        const _that = this
        _that.form= Object.assign({}, form),
        _that.dialogTitle = '增加人员档案'
        _that.dialogStatus = '1';
        _that.dialogVisible = true;

      },
      //刷新变革
      tableRefresh(){
        //刷新变革
        this.getInfo()
      },
      //增加人员档案
      addBtn(){
        const _that = this
        var personFileInfo =JSON.stringify(_that.form)
        var data = {
          "personFileInfo": personFileInfo ,
        }
        // console.log(data);
        // return

        addPersonFileInfo(data).then(res => {
          // console.log(res);
          if(res.httpCode == 200){
            _that.dialogVisible = false
            _that.$message({
              message: '增加成功',
              type: 'success'
            });
            _that.tableRefresh();
          }else{
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })
      },

      //唤起修改
      handleUpdate(row){
        const _that = this;
        _that.form = {
          loginName:'',
          userName:'',
          email:'',
          phoneNumber:'',
          sex:'',
          password:'',
        }

        _that.dialogTitle = '修改人员档案信息'
        _that.dialogVisible = true
        _that.dialogStatus = '2';

        var idPrint = row.id
        var data= {
          id : idPrint
        }

        getPersonFileInfoByID(data).then(res => {
          console.log(res);
          const data = res.data

          _that.form={
              id:data.id,
              loginName:data.loginName,
              userName:data.userName,
              email:data.email,
              phoneNumber:data.phoneNumber,
              sex:data.sex,
              password:data.password,
            }
        }).catch(err => {
          _that.$message.error(err)
        })
      },
      //修改人员档案
      editBtn(){
        const _that = this
        var personFileInfo =JSON.stringify(_that.form)
        var data = {
          "personFileInfo": personFileInfo ,
        }

        updatePersonFileInfo(data).then(res => {
          // console.log(res);
          if(res.httpCode == 200){
            _that.dialogVisible = false
            _that.$message({
              message: '修改成功',
              type: 'success'
            });
            _that.tableRefresh();
          }else{
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })

      },

      //启用禁用
      editStatus(id,status){
        var _that = this;
        var personFileInfo = {
          id:id,
          delFlag:status
        }
        var params = {
          "personFileInfo": JSON.stringify(personFileInfo),
        }

        var url = '/baseinfo/voidPersonFileInfo';
        _that.$refs.confirmDialog.updataClick(params, url);
      },


      //搜索
      searchData(){
        this.listData.page = 1;
        this.getInfo()
      }
    }
  }
</script>

<style lang="scss" scoped>
  .filter-container {
    margin-bottom: 15px;
  }
</style>
